=== debian/changelog ===
ros-dashing-rclcpp (0.7.16-1bionic) bionic; urgency=high

  * Fix documented example in create_publisher. (#1558 <https://github.com/ros2/rclcpp/issues/1558>) (#1560 <https://github.com/ros2/rclcpp/issues/1560>)
  * Fix NodeOptions copy constructor. (#1376 <https://github.com/ros2/rclcpp/issues/1376>) (#1466 <https://github.com/ros2/rclcpp/issues/1466>)
  * Contributors: Ivan Santiago Paunovic, Jacob Perron

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 21 May 2021 07:00:00 -0000

ros-dashing-rclcpp (0.7.15-1bionic) bionic; urgency=high

  * Fix implementation of NodeOptions::use_global_arguments(). (#1176 <https://github.com/ros2/rclcpp/issues/1176>) (#1206 <https://github.com/ros2/rclcpp/issues/1206>)
  * Fix conversion of negative durations to messages. (#1188 <https://github.com/ros2/rclcpp/issues/1188>) (#1207 <https://github.com/ros2/rclcpp/issues/1207>)
  * Type conversions fixes. (#901 <https://github.com/ros2/rclcpp/issues/901>) (#1209 <https://github.com/ros2/rclcpp/issues/1209>)
  * Add operator!= for duration (#1236 <https://github.com/ros2/rclcpp/issues/1236>) (#1277 <https://github.com/ros2/rclcpp/issues/1277>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo, Monika Idzik

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 24 Nov 2020 08:00:00 -0000

ros-dashing-rclcpp (0.7.14-1bionic) bionic; urgency=high

  * Fixed doxygen warnings. (#1208 <https://github.com/ros2/rclcpp/issues/1208>)
  * Check if context is valid when looping in spin_some. (#1167 <https://github.com/ros2/rclcpp/issues/1167>)
  * Fix spin_until_future_complete: check spinning value. (#1023 <https://github.com/ros2/rclcpp/issues/1023>)
  * Fix exception on rcl_clock_init. (#1195 <https://github.com/ros2/rclcpp/issues/1195>)
  * Fix lock-order-inversion (potential deadlock). (#1138 <https://github.com/ros2/rclcpp/issues/1138>)
  * Contributors: Alejandro Hernández Cordero, DongheeYe, Ivan Santiago Paunovic, tomoya

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 10 Jul 2020 07:00:00 -0000

ros-dashing-rclcpp (0.7.13-1bionic) bionic; urgency=high

  * Don't specify calling convention in std::_Binder template. (#1015 <https://github.com/ros2/rclcpp/issues/1015>)
  * Contributors: Jacob Perron, Sean Kelly

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 12 Mar 2020 07:00:00 -0000

ros-dashing-rclcpp (0.7.12-1bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 05 Dec 2019 08:00:00 -0000

ros-dashing-rclcpp (0.7.11-1bionic) bionic; urgency=high

  * Fix get_node_*_interface functions taking a pointer (#870 <https://github.com/ros2/rclcpp/pull/870>).
  * Fix hang with timers in MultiThreadedExecutor (#869 <https://github.com/ros2/rclcpp/pull/869>).
  * Contributors: Todd Malsbary, ivanpauno

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 11 Oct 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.10-1bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 23 Sep 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.9-1bionic) bionic; urgency=high

  * add mutex in add/remove_node and wait_for_work to protect concurrent use/change of memory_strategy_ (#837 <https://github.com/ros2/rclcpp/issues/837>) (#857 <https://github.com/ros2/rclcpp/issues/857>)
  * Contributors: Zachary Michaels

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 20 Sep 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.8-1bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 06 Sep 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.7-1bionic) bionic; urgency=high

  * Enabled the creation of a parameter YAML file which is applied to each node. (#805 <https://github.com/ros2/rclcpp/issues/805>)
  * Fixed a signed/unsigned integer comparison compiler warning. (#804 <https://github.com/ros2/rclcpp/issues/804>)
  * Changed the QoS profile used when subscribing to parameter events to match the publishing side, i.e. ``rmw_qos_profile_parameter_events``. (#798 <https://github.com/ros2/rclcpp/issues/798>)
  * Changed the logic in TimeSource to ignore use_sim_time parameter events coming from other nodes. (#803 <https://github.com/ros2/rclcpp/issues/803>)
  * Added missing default values in the NodeParametersInterface. (#794 <https://github.com/ros2/rclcpp/issues/794>)
  * Added support for const member callback functions. (#763 <https://github.com/ros2/rclcpp/issues/763>)
  * Contributors: Esteve Fernandez, Gonzo, Karsten Knese, Michel Hidalgo, Scott K Logan

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 31 Jul 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.6-1bionic) bionic; urgency=high

  * Ignore parameters overrides in set parameter methods when allowing undeclared parameters (#756 <https://github.com/ros2/rclcpp/issues/756>)
  * Add rclcpp::create_timer() (#757 <https://github.com/ros2/rclcpp/issues/757>)
  * checking origin of intra-process msg before taking them (#753 <https://github.com/ros2/rclcpp/issues/753>)
  * Contributors: Alberto Soragna, Shane Loretz, ivanpauno

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 12 Jun 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.5-1bionic) bionic; urgency=high

  * Avoid 'Intra process message no longer being stored when trying to handle it' warning (#749 <https://github.com/ros2/rclcpp/issues/749>)
  * Contributors: ivanpauno

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 30 May 2019 07:00:00 -0000

ros-dashing-rclcpp (0.7.4-1bionic) bionic; urgency=high

  * Rename parameter options (#745 <https://github.com/ros2/rclcpp/issues/745>)
  * Bionic use of strerror_r (#742 <https://github.com/ros2/rclcpp/issues/742>)
  * Enforce parameter ranges (#735 <https://github.com/ros2/rclcpp/issues/735>)
  * removed not used parameter client (#740 <https://github.com/ros2/rclcpp/issues/740>)
  * ensure removal of guard conditions of expired nodes from memory strategy (#741 <https://github.com/ros2/rclcpp/issues/741>)
  * Fix typo in log warning message (#737 <https://github.com/ros2/rclcpp/issues/737>)

