=== debian/control ===
Source: ros-dashing-rclcpp
Section: misc
Priority: optional
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-dashing-ament-cmake-gmock, ros-dashing-ament-cmake-gtest, ros-dashing-ament-cmake-ros, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-builtin-interfaces, ros-dashing-rcl, ros-dashing-rcl-interfaces, ros-dashing-rcl-yaml-param-parser, ros-dashing-rmw, ros-dashing-rmw-implementation, ros-dashing-rmw-implementation-cmake, ros-dashing-rosgraph-msgs, ros-dashing-rosidl-generator-cpp, ros-dashing-rosidl-typesupport-c, ros-dashing-rosidl-typesupport-cpp, ros-dashing-test-msgs, ros-dashing-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-dashing-rclcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-dashing-ament-cmake, ros-dashing-builtin-interfaces, ros-dashing-rcl, ros-dashing-rcl-interfaces, ros-dashing-rcl-yaml-param-parser, ros-dashing-rmw, ros-dashing-rmw-implementation, ros-dashing-rosgraph-msgs, ros-dashing-rosidl-generator-cpp, ros-dashing-rosidl-typesupport-c, ros-dashing-rosidl-typesupport-cpp, ros-dashing-ros-workspace
Description: The ROS client library in C++.
